<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      //   Деструктуризация подразумевает разбивку сложной структуры
      //   на простые части. В JavaScript, таковая сложная структура обычно является объектом
      //   или массивом. Используя синтаксис деструктуризации,
      //   вы можете выделить маленькие фрагменты из массивов или объектов.
      // class Employee {
      //   constructor(name, age, salary) {
      //     this.name = name;
      //     this.age = age;
      //     this.salary = salary;
      //   }
      //   getName() {
      //     return this.name;
      //   }
      //   getAge() {
      //     return this.age;
      //   }
      //   getSalary() {
      //     return this.salary;
      //   }
      //   checkAge() {
      //     return this.age >= 18;
      //   }
      // }

      // const employee1 = new Employee("Yuriy", 40, 100000);

      // Перепишем на то, что передаем аргументы объектом
      // class Employee {
      //   constructor(config) {
      //     this.name = config.name;
      //     this.age = config.age;
      //     this.salary = config.salary;
      //   }
      //   getName() {
      //     return this.name;
      //   }
      //   getAge() {
      //     return this.age;
      //   }
      //   getSalary() {
      //     return this.salary;
      //   }
      //   checkAge() {
      //     return this.age >= 18;
      //   }
      // }

      // const employee1 = new Employee({
      //   name: "Yuriy",
      //   age: 18,
      //   salary: 10000,
      // // });

      // Применим деструктуризацию

      // class Employee extends TestClass {
      //   constructor(config) {
      //     // Деструктурируем объект
      //     const { name, age, salary } = config;

      //     const name = config.name;
      //     const salary = config.salary;

      //     this.name = name;
      //     this.age = age;
      //     this.salary = salary;
      //   }
      //   getName() {
      //     return this.name;
      //   }
      //   getAge() {
      //     return this.age;
      //   }
      //   getSalary() {
      //     return this.salary;
      //   }
      //   checkAge() {
      //     return this.age >= 18;
      //   }
      // }

      // const employee1 = new Employee({
      //   name: "Yuriy",
      //   age: 18,
      //   salary: 10000,

      //   testClassData: {
      //     newAge: 40,
      //     property: "Ira",
      //   },
      // });

      //   // Упростим еще больше
      // class TestClass {
      //   constructor({}) {
      //     this.newAge = newAge;
      //   }
      // }
      // class Employee extends TestClass {
      //   // Деструктурируем объект
      //   constructor(config) {
      //     const { name, age, salary, newAge, testClassData } = config;
      //     super(testClassData);
      //     this.name = name;
      //     this.age = age;
      //     this.salary = salary;
      //   }
      //   getName() {
      //     return this.name;
      //   }
      //   getAge() {
      //     return this.age;
      //   }
      //   getSalary() {
      //     return this.salary;
      //   }
      //   checkAge() {
      //     return this.age >= 18;
      //   }
      // }

      // const employee1 = new Employee({
      //   name: "Yuriy",
      //   age: 18,
      //   salary: 10000,
      // });

      // function summ(a, b = 0) {
      //    return a + b;
      // }

      // summ(1); // 1
      // summ(1, 2); // 3

      // const user = {
      //   login: "Irina",
      //   isAdmin: true,
      //   age: 27,
      // };

      // const { login, isAdmin, age = 25 } = user;

      // console.log(login, isAdmin, age);

      // Деструктуризация вложенных объектов
      // const user = {
      //   login: "Irina",
      //   isAdmin: true,
      //   experience: {
      //     years: 3,
      //     lang: "JS",
      //   },
      // };

      // const user1 = {
      //   login: "Irina",
      //   isAdmin: true,
      //   experience: {
      //     years: 3,
      //     lang: "JS",
      //   },
      // };

      // const arrayOfObjects = [user, user1];
      // arrayOfObjects.forEach((element) => {
      //   const {
      //     login,
      //     isAdmin,
      //     age = 25,
      //     experience: { years, lang },
      //   } = element;
      //   const phrase = `Hi, I'm ${login}, I have ${years} experience`;
      // });

      // const {
      //   login,
      //   isAdmin,
      //   age = 25,
      //   experience: { years, lang },
      // } = user;

      // const phrase = `Hi, I'm ${user.login}, I have ${user.experience.years} experience`;
      // const phrase = `Hi, I'm ${login}, I have ${years} experience`;

      // // // Деструктуризация массива
      // const point = [3, 5];

      // // console.log(`${point[0]}:${point[1]}`); // => 3:5

      // // // Добавим переменные
      // const pointOfUkraine = point[0];
      // const pointOfSpain = point[1];

      // console.log(`${pointOfUkraine}:${pointOfSpain}`); // => 3:5

      // // Используем деструктуризацию чтоб сократить
      // const [pointOfUkraine, pointOfSpain] = point;
      // // Слева массив повторяет структуру правого массива
      // // но вместо значений используются идентификаторы
      // // они заполняются значениями, стоящими на тех же позициях в правом массиве
      //  [pointOfUkraine, pointOfSpain] = [3, 5]
      // // x = 3, y = 5
      // console.log(`${x}:${y}`); // => 3:5

      // // Можно извлекать только отдельные элементы

      // // Извлекаем первый элемент
      // // Остальные игнорируются
      // const [pointOfUkraine] = point;
      // // Извлекаем второй элемент

      // // Для этого просто не указываем первый
      // const [, pointOfSpain] = point;

      // и даже так
      // const [, secondElement, , fourthElement, fifthElement] = [
      //   1, 2, 3, 4, 5, 6,
      // ];

      // console.log(secondElement); // => 2
      // console.log(fourthElement); // => 4
      // console.log(fifthElement); // => 5

      // //  Присваивание дефолтных значений работает также как в объектах
      // const [firstElement, secondElement, thirdElement = 3] = [1, 2];

      // Оператор ... может быть rest оператором, может быть spread

      // const iterable = document.getElementsByClassName("class"); // HtmlCollection

      // все элементы iterable записываются в новый массив
      // const array = [...document.getElementsByClassName("class")];

      // Можем склеить 2 массива в 1
      // const array1 = [1, 2];
      // const array2 = [3, 4];

      // let mergedArray = [...array1, ...array2];

      // let mergedArray = [...array1, ...array2];

      // Можно копировать объекты (но без сохранения прототипа)
      // let firstObject = { a: 1, b: 3 };
      // let secondObject = { a: 2, c: 4 };

      // let mergedObject = {
      //   a: 5,
      //   b: 1,
      //   c: 1,
      //   ...firstObject,
      //   ...secondObject,

      // };

      // console.log(mergedObject);

      //  Оператор rest
      // const func = (a, b, ...args) => {
      //   console.log(a);
      //   console.log(params);
      // };

      // func(1, 3, 4, 5);

      // function func1() {
      //   console.log(arguments);
      // }

      // func1(1, 2, 3, 4);
    </script>
  </body>
</html>
